#!@perlpath@

################################################################################
##   reply is used to evaluate the responses from the external Whois DBs
##										
##   Copyright (c) 2000 - 2004 Arnd Vehling <av@nethead.de>			
##   Copyright (c) 2003 - 2004 Cable & Wireless	<ripe-software.cw.net>		
##										
##										
##										
##   This file is part of ripe-ipadmin.						
##										
##   ripe-ipadmin is free software; you can redistribute it and/or modify	
##   it under the terms of the GNU General Public License as published by	
##   the Free Software Foundation; either version 2 of the License, or		
##   (at your option) any later version.					
##										
##   ripe-ipadmin is distributed in the hope that it will be useful,		
##   but WITHOUT ANY WARRANTY; without even the implied warranty of		
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the		
##   GNU General Public License for more details.				
##										
##   You should have received a copy of the GNU General Public License		
##   along with ripe-ipadmin; if not, write to the Free Software		
##   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA	
##										
##    $Id: reply.pl,v 1.4 2004/12/03 21:00:26 tcremer Exp $			
##										
################################################################################


# /////////////////////////////////////////////////////////////////////////////
# Filename          : ripadm.pl
# Purpose           :
#
# Author            : NetHead / info@nethead.de / http://nethead.de
#
# Description       :
# OSs Tested        : Linux, SunOS 5.8
# Command Line      : starting without options will give you help
#
# Comments          : Checks the replies from the ripe-robot from
#                   : mails created by "ripadm.pl"
#
# Version           : 1.1
# Date:             : 2003-07-03
# /////////////////////////////////////////////////////////////////////////////

use strict;

BEGIN: { require "@confdir@/ripadm.conf" }

&main;
exit;

sub main
{

# Init...

        my %my_header;
        my @my_body;
        my $tmp_status = 0;
        my $my_replystatus = 1; # first ok
 
###
### e-mail einlesen
###
 
        for (<STDIN>)
        {
        chomp $_;
 
        if ($tmp_status == 0)
                {
                # Header
                if ($_ eq '') {$tmp_status=1; next} else
                        {
                        if (/^([a-zA-Z]*): (.+)/) {$my_header{$1}=$2}
                        }
 
                } else
                {
                # Body
 
                if ($_ ne '') {push @my_body, $_;}
 
                }
        }
	my @tmp_body = @my_body; 

###
### Header checken...
###

# [...]
 
###
### Body parsen
###
 
###
#
# replystatus:
#
# 0->kein Status
# 1->OK
# 2->FAILED
# 9->Unbekannt
#

	$my_replystatus = 1;

	for (@my_body)
		{

        if 	(/Number of objects processed with errors:\s+(\d+)/) { if ($1 > 0) {$my_replystatus = 2} }

		}

	my $my_id;
	my $my_typ; 
	my $my_proc;
	my $my_ok = 0;

	my $tmp = 0;
	my @tmp_data;
	my $tmp_msg;

	my @orgmail = ();

	for (@my_body)
	{
	if      (/\>\s+Message-ID:\s+(\d+)\.([a-zA-Z]*)\.(\d+)\@\w+\.eu\.cw\.net/i) {$my_id = $1; $my_typ = $2; $my_proc = $3; $my_ok = 1;}
	elsif 	(/The following object/) {$tmp = 1; next;}
	elsif 	((/^[A-Za-z]+/) and ($tmp)) {push @tmp_data, $_}
	}

	if (($my_replystatus > 1) and ($my_ok))
	{
	open(DUMMY,"$Conf::dir{'objects_send'}/$my_id.$my_typ.$my_proc");
	@orgmail = <DUMMY>;
	close(DUMMY);
	}	


###
### Datei verschieben
###

	if ($my_ok)
	{

	`/bin/mv $Conf::dir{'objects_send'}/$my_id.$my_typ.$my_proc $Conf::dir{'objects_done'}`;
### 
### e-mail verschicken
### 

	if	($my_replystatus == 2) {$tmp_msg = "Fehler beim Abgleich\n"; &message("ID:$my_id $tmp_data[0] ERROR")}
	elsif 	($my_replystatus == 1) {$tmp_msg = "Objekt erfolgreich abgeglichen\n"; &message("ID:$my_id $tmp_data[0] OK")}
	else {$tmp_msg = "Unbekannte Antwort beim Abgleich\n"; &message("ID:$my_id $tmp_data[0] PARSE ERROR")}	

        if (($my_replystatus == 1) and ($Conf::debug_config{'reply_sendok'} == 0)) {exit;}
        pop @tmp_data;

	} else {$tmp_msg = "Unknown format in email"; &message("Error: Unknown format in email");}
 
        if ($Conf::mail{'mailerrors'} ne '')
        {
        open(MAIL,$Conf::mail{'prog'});
        print MAIL <<END;
From: $Conf::mail{'mailerrors'}
To: $Conf::mail{'mailerrors'}
Subject: $tmp_data[0]

$tmp_msg
Object-ID: $my_id (Ref: $Conf::dir{'objects_done'}/$my_id.$my_typ.$my_proc) 
END
	for (@tmp_data) {print MAIL "$_\n"}


# on_error reply full_mail
	if ($my_ok == 0) {print MAIL "Mail:\n"; for (@tmp_body) {print MAIL "$_\n"}} 

	if (@orgmail)
	{
	print MAIL "\n########## ORGINAL E-MAIL ##########\n";
	for (@orgmail) {if ($_ =~ /^password: /) {print MAIL "password: ********\n"} else {print MAIL $_}}
	}

        close(MAIL);
        } # if mailerrors
}

sub message
{
 
        my ($t_sec, $t_min, $t_std, $t_tag, $t_mon, $t_jahr, undef, undef, undef) = localtime(time);
        $t_mon++; if ($t_mon == 13) {$t_mon = 1}
        $t_jahr += 1900;
        for ($t_sec, $t_min, $t_std, $t_tag, $t_mon)
        {
        $_ =~ s/^(\d)$/0$1/;
        }
 
        my $date = "$t_jahr-$t_mon-$t_tag $t_std:$t_min:$t_sec";
        if ($Conf::file{'replylog'} ne '')
        {
        open(LOG,">>$Conf::file{'replylog'}");
        print LOG "$date $_[0]\n";
        close(LOG);
        }
        else
        {
        print "$date $_[0]\n";
        }
}
